/*!
  * @yzcode/vue-devtool-vuex-z v0.0.8
  * (c) 2021 
  * @license MIT
  */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var devtoolsApi = require('@vue/devtools-api');

const storeGetters = '朝哥最屌getters';
const storeState = '朝哥最屌state';
function setupDevtools(app, { store }) {
    devtoolsApi.setupDevtoolsPlugin({
        id: '@yzcode/vue-devtool-vuex-z',
        label: 'vue-devtool-vuex',
        packageName: '@yzcode/vue-devtool-vuex-z',
        homepage: 'my home',
        app,
        componentStateTypes: [storeGetters, storeState],
    }, (api) => {
        // api.addInspector({
        //   id: inspectorId,
        //   label: 'vuex',
        //   icon: 'pets',
        // });
        store.subscribe((mutation, state) => {
            api.notifyComponentUpdate();
        });
        api.on.inspectComponent((payload, context) => {
            Object.keys(store.state).forEach((key) => {
                payload.instanceData.state.push({
                    type: storeState,
                    key,
                    value: store.state[key],
                });
            });
            Object.keys(store.getters).forEach((key) => {
                payload.instanceData.state.push({
                    type: storeGetters,
                    key,
                    value: store.getters[key],
                });
            });
        });
    });
}
var index = {
    install(app, options) {
        // Our Vue plugin logic
        {
            setupDevtools(app, options);
        }
    },
};

exports['default'] = index;
exports.setupDevtools = setupDevtools;
