import { setupDevtoolsPlugin } from '@vue/devtools-api';
import { App } from 'vue';
import { Store } from 'vuex';

const storeGetters = '朝哥最屌getters';
const storeState = '朝哥最屌state';

// const inspectorId = 'vuex-z-plugin';

declare global {
  const __VUE_PROD_DEVTOOLS__: boolean;
}

interface PluginOptions {
  store: Store<any>;
}
export function setupDevtools(app: App, { store }: PluginOptions) {
  setupDevtoolsPlugin(
    {
      id: '@yzcode/vue-devtool-vuex-z',
      label: 'vue-devtool-vuex',
      packageName: '@yzcode/vue-devtool-vuex-z',
      homepage: 'my home',
      app,
      componentStateTypes: [storeGetters, storeState],
    },
    (api) => {
      // api.addInspector({
      //   id: inspectorId,
      //   label: 'vuex',
      //   icon: 'pets',
      // });
      store.subscribe((mutation, state) => {
        api.notifyComponentUpdate();
      });

      api.on.inspectComponent((payload, context) => {
        Object.keys(store.state).forEach((key) => {
          payload.instanceData.state.push({
            type: storeState,
            key,
            value: store.state[key],
          });
        });

        Object.keys(store.getters).forEach((key) => {
          payload.instanceData.state.push({
            type: storeGetters,
            key,
            value: store.getters[key],
          });
        });
      });
    }
  );
}

export default {
  install(app: App, options: PluginOptions) {
    // Our Vue plugin logic
    if (process.env.NODE_ENV === 'development' || __VUE_PROD_DEVTOOLS__) {
      setupDevtools(app, options);
    }
  },
};
